/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023  SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.towerrun.state;

import lombok.Getter;
import lombok.experimental.UtilityClass;

import java.util.ArrayList;
import java.util.List;

@UtilityClass
public class GameState {
    @Getter
    private static GameStates currentState = GameStates.WAITING;
    private static final List<GameStateListener> gameStateListeners = new ArrayList<>();

    public static void addGameStateListener(GameStateListener gameStateListener) {
        gameStateListeners.add(gameStateListener);
    }

    public static void nextState() {
        final GameStates oldState = currentState;
        currentState = currentState.getNextState();
        gameStateChanges(oldState, currentState);
    }

    static void setState(final GameStates newState) {
        final GameStates oldState = currentState;
        currentState = newState;
        gameStateChanges(oldState, currentState);
    }

    public static void reset() {
        final GameStates oldState = currentState;
        currentState = GameStates.WAITING;
        gameStateChanges(oldState, currentState);
    }

    private static void gameStateChanges(GameStates oldState, GameStates newState) {
        gameStateListeners.forEach(gameStateListener -> gameStateListener.onGameStateChange(oldState, newState));
    }
}
